<?php

declare(strict_types=1);

namespace Dedi\SyliusBlogPlugin\Entity;

use Dedi\SyliusBlogPlugin\Domain\Blog\Adapter\ArticleInterface as BaseDomainArticleInterface;
use Dedi\SyliusBlogPlugin\Domain\Blog\Adapter\AuthorInterface;
use Doctrine\Common\Collections\Collection;
use Sylius\Component\Core\Model\ChannelInterface;
use Sylius\Component\Resource\Model\ResourceInterface;

interface ArticleInterface extends ResourceInterface, AppTranslatableInterface, BaseDomainArticleInterface
{
    public function setPosition(int $position): self;

    public function setEnabled(bool $enabled): self;

    public function setSlug(string $slug): self;

    public function getSlug(): string;

    public function setTitle(string $title): self;

    public function setContent(string $content): self;

    public function setAuthor(?AuthorInterface $author): self;

    public function setCategories(Collection $categories): self;

    public function hasCategories(): bool;

    public function addCategory(CategoryInterface $category): bool;

    public function removeCategory(CategoryInterface $category): bool;

    public function getChannels(): Collection;

    public function setChannels(Collection $channels): self;

    public function addChannel(ChannelInterface $channel): bool;

    public function removeChannel(ChannelInterface $channel): bool;

    public function getComments();

    public function addComment(CommentInterface $comment): self;
}
