<?php

declare(strict_types=1);

namespace Dedi\SyliusBlogPlugin\Entity;

use Dedi\SyliusBlogPlugin\Domain\Blog\Adapter\CategoryInterface as BaseDomainArticleCategoryInterface;
use Doctrine\Common\Collections\Collection;
use Sylius\Component\Core\Model\ChannelInterface;
use Sylius\Component\Resource\Model\ResourceInterface;

interface CategoryInterface extends ResourceInterface, AppTranslatableInterface, BaseDomainArticleCategoryInterface
{
    public function setEnabled(bool $enabled): self;

    public function setPosition(int $position): self;

    public function setSlug(string $slug): self;

    public function setName(string $name): self;

    public function setDescription(?string $description): self;

    public function hasArticles(): bool;

    public function setSubCategories(Collection $subCategories): self;

    public function hasSubCategories(): bool;

    public function addSubCategory(self $category): bool;

    public function removeSubCategory(self $category): bool;

    public function getParents(): Collection;

    public function hasParents(): bool;

    public function getChannels(): Collection;

    public function setChannels(Collection $channels): self;

    public function addChannel(ChannelInterface $channel): bool;

    public function removeChannel(ChannelInterface $channel): bool;
}
